----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Prince Taldaram"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 591 $"):sub(12, -3)))
if not mod then return end
mod.partycontent = true
mod.otherMenu = "Dragonblight"
mod.zonename = BZ["Ahn'kahet: The Old Kingdom"]
mod.enabletrigger = boss
mod.guid = 29308
mod.toggleOptions = {"embraceGain","embraceFade","embraceBar",-1,"sphere","bosskill"}

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Taldaram",
	embraceBar = "Embrace of the Vampyr Bar",
	embraceBar_desc = "Display a bar for the duration of Embrace of the Vampyr.",
	embraceFade = "Embrace of the Vampyr Fades",
	embraceFade_desc = "Announce when Embrace of the Vampyr fades from Prince Taldaram.",
	embraceFade_message = "Embrace of the Vampyr Fades",
	embraceGain = "Embrace of the Vampyr Gained",
	embraceGain_desc = "Announce when Prince Taldaram gains Embrace of the Vampyr.",
	embraceGain_message = "Embrace of the Vampyr Gained",
	sphere = "Conjure Flame Sphere",
	sphere_desc = "Warn when Prince Taldaram begins conjuring a Flame Sphere.",
	sphere_message = "Conjuring Flame Sphere",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Taldaram",
	embraceBar = "Umarmung des Vampyrs-Anzeige",
	embraceBar_desc = "Eine Leiste für die Dauer von Umarmung des Vampyrs anzeigen.",
	embraceFade = "Umarmung des Vampyrs verblasst",
	embraceFade_desc = "Ankündigen wenn die Umarmung des Vampyrs von Prinz Taldaram verblasst.",
	embraceFade_message = "Umarmung des Vampyrs schwindet!",
	embraceGain = "Umarmung des Vampyrs erhalten!",
	embraceGain_desc = "Ankündigen wenn Prinz Taldaram die Umarmung des Vampyrs erhält.",
	embraceGain_message = "Umarmung des Vampyrs erhalten!",
	sphere = "Flammensphäre beschwören",
	sphere_desc = "Warnung wenn Prinz Taldaram beginnt, eine Flammensphäre zu beschwören.",
	sphere_message = "Beschwört Flammensphäre!",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Taldaram",
	embraceBar = "Etreinte du vampire - Barre",
	embraceBar_desc = "Affiche une barre indiquant la durée de l'Etreinte du vampire.",
	embraceFade = "Etreinte du vampire - Fin",
	embraceFade_desc = "Prévient quand Etreinte du vamprie disparait du Prince Taldaram.",
	embraceFade_message = "Etreinte du vampire terminée",
	embraceGain = "Etreinte du vampire - Gain",
	embraceGain_desc = "Prévient quand le Prince Taldaram gagne l'Etreinte du vampire.",
	embraceGain_message = "Etreinte du vampire lancée",
	sphere = "Invocation d'une sphère de flammes",
	sphere_desc = "Prévient quand le Prince Taldaram commence à invoquer une sphère de flammes.",
	sphere_message = "Invocation d'une sphère de flammes en cours",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "탈다람",
	embraceBar = "흡혈의 은총 바",
	embraceBar_desc = "흡혈의 은총이 지속되는 바를 표시합니다.",
	embraceFade = "흡혈의 은총 사라짐",
	embraceFade_desc = "공작 탈다람에게서 흡혈의 은총이 사라짐을 알립니다.",
	embraceFade_message = "흡혈의 은총 사라짐",
	embraceGain = "흡혈의 은총 획득",
	embraceGain_desc = "공작 탈다람의 흡혈의 은총 획득을 알립니다.",
	embraceGain_message = "흡혈의 은총 획득!",
	sphere = "화염 구슬 소환",
	sphere_desc = "공작 탈다람의 화염 구슬 소환 시전을 알립니다.",
	sphere_message = "화염 구슬 소환!",
}

end )

L:RegisterTranslations("ruRU", function() return {
	cmd = "Taldaram",
	embraceBar = "Полоса Объятия вампира",
	embraceBar_desc = "Отображать полосу продолжительности Объятия вампира.",
	embraceFade = "Рассеивание Объятия вампира",
	embraceFade_desc = "Сообщать, когда Объятие вампира спадает с Принца Талдарама.",
	embraceFade_message = "Объятие вампира рассеивается",
	embraceGain = "Получение Объятия вампира",
	embraceGain_desc = "Сообщать, когда Принц Талдарам получает Объятие вампира.",
	embraceGain_message = "Получено Объятие вампира",
	sphere = "Создание сферы огня",
	sphere_desc = "Предупреждать, когда Принц Талдарам начинает Создание сферы огня.",
	sphere_message = "Создание сферы огня",
}

end )

L:RegisterTranslations("zhCN", function() return {
	embraceBar = "吸血鬼的拥抱计时条",
	embraceBar_desc = "当吸血鬼的拥抱持续时显示计时条。",
	embraceFade = "吸血鬼的拥抱消失",
	embraceFade_desc = "当吸血鬼的拥抱从塔达拉姆王子消失时发出警报。",
	embraceFade_message = "已消失 吸血鬼的拥抱！",
	embraceGain = "获得吸血鬼的拥抱",
	embraceGain_desc = "当塔达拉姆王子获得吸血鬼的拥抱时发出警报。",
	embraceGain_message = "已获得 吸血鬼的拥抱！",
	sphere = "制造烈焰之球",
	sphere_desc = "当塔达拉姆王子开始制造烈焰之球时发出警报。",
	sphere_message = "制造烈焰之球！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "泰爾達朗",
	embraceBar = "吸血鬼之擁計時條",
	embraceBar_desc = "當吸血鬼之擁持續時顯示計時條。",
	embraceFade = "吸血鬼之擁消失",
	embraceFade_desc = "當吸血鬼之擁從泰爾達朗王子消失時發出警報。",
	embraceFade_message = "已消失 吸血鬼之擁！",
	embraceGain = "吸血鬼之擁",
	embraceGain_desc = "當泰爾達朗王子獲得吸血鬼之擁時發出警報。",
	embraceGain_message = "已獲得 吸血鬼之擁！",
	sphere = "製造裂焰之球",
	sphere_desc = "當泰爾達朗王子開始製造裂焰之球時發出警報。",
	sphere_message = "製造裂焰之球！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "Embrace", 55959, 59513)
	self:AddCombatListener("SPELL_AURA_REMOVED", "EmbraceRemoved", 55959, 59513)
	self:AddCombatListener("SPELL_CAST_START", "Sphere", 55931)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Embrace(_, spellId, _, _, spellName)
	if self.db.profile.embraceGain then
		self:IfMessage(L["embraceGain_message"], "Important", spellId)
	end
	if self.db.profile.embraceBar then
		self:Bar(spellName, 20, spellId)
	end
end

function mod:EmbraceRemoved(_, spellId, _, _, spellName)
	if self.db.profile.embraceFade then
		self:IfMessage(L["embraceFade_message"], "Positive", spellId)
	end
	if self.db.profile.embraceBar then
		self:TriggerEvent("BigWigs_StopBar", self, spellName)
	end
end

function mod:Sphere(_, spellId)
	if self.db.profile.sphere then
		self:IfMessage(L["sphere_message"], "Important", spellId)
	end
end
