----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Loken"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 588 $"):sub(12, -3)))
if not mod then return end
mod.partycontent = true
mod.otherMenu = "The Storm Peaks"
mod.zonename = BZ["Halls of Lightning"]
mod.enabletrigger = boss
mod.guid = 28586
mod.toggleOptions = {"nova","novaBar","bosskill"}

----------------------------------
--        Are you local?        --
----------------------------------

local casttime
local difficulty

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Loken",
	nova = "Lightning Nova",
	novaBar = "Lightning Nova Bar",
	novaBar_desc = "Show a bar for the cast time of Lightning Nova.",
	nova_desc = "Warn for the casting of Lightning Nova.",
	nova_message = "Casting Lightning Nova",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Loken",
	nova = "Blitznova",
	novaBar = "Blitznova Bar",
	novaBar_desc = "Eine Leiste für die Zauberzeit von Blitznova anzeigen.",
	nova_desc = "Warnt vor dem Zaubern von Blitznova.",
	nova_message = "Zaubert Blitznova",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Loken",
	nova = "Nova de foudre",
	novaBar = "Nova de foudre - Barre",
	novaBar_desc = "Affiche une barre indiquant la durée de l'incantation de la Nova de foudre.",
	nova_desc = "Prévient quand la Nova de foudre est incantée.",
	nova_message = "Nova de foudre en incantation",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "로켄",
	nova = "번개 회오리",
	novaBar = "번개 회오리 바",
	novaBar_desc = "번개 회오리 시전 시간바를 표시합니다.",
	nova_desc = "번개 회오리 시전을 알립니다.",
	nova_message = "번개 회오리 시전",
}

end )

L:RegisterTranslations("ruRU", function() return {
	cmd = "Loken",
	nova = "Вспышка молнии",
	novaBar = "Полоса вспышки молнии",
	novaBar_desc = "Отображать полосу применения вспышки молнии.",
	nova_desc = "Предупреждать о применении вспышки молнии.",
	nova_message = "Применяется вспышка молнии",
}

end )

L:RegisterTranslations("zhCN", function() return {
	nova = "闪电新星",
	novaBar = "闪电新星计时条",
	novaBar_desc = "当施放闪电新星时显示计时条。",
	nova_desc = "当施放闪电新星时发出警报。",
	nova_message = "正在施放 闪电新星！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "洛肯",
	nova = "閃電新星",
	novaBar = "閃電新星計時條",
	novaBar_desc = "當施放閃電新星時顯示計時條。",
	nova_desc = "當施放閃電新星時發出警報。",
	nova_message = "正在施放 閃電新星！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_START", "Nova", 52960, 59835)
	self:AddCombatListener("UNIT_DIED", "BossDeath")

	difficulty = GetInstanceDifficulty()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Nova(_, spellId, _, _, spellName)
	if self.db.profile.nova then
		self:IfMessage(L["nova_message"], "Urgent", spellId)
	end
	if self.db.profile.novaBar then
		if difficulty == 1 then casttime = 5 else casttime = 4 end
		self:Bar(spellName, casttime, spellId)
	end
end
